Source-Changes-HG archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

[src/trunk]: src/tests/sbin/ifconfig Add a test case for kern/52771.



details:   https://anonhg.NetBSD.org/src/rev/1c910ef7f642
branches:  trunk
changeset: 935136:1c910ef7f642
user:      jruoho <jruoho%NetBSD.org@localhost>
date:      Thu Jun 25 15:41:40 2020 +0000

description:
Add a test case for kern/52771.

diffstat:

 distrib/sets/lists/tests/mi              |   3 +-
 tests/sbin/ifconfig/Makefile             |   4 +-
 tests/sbin/ifconfig/t_repeated_updown.sh |  70 ++++++++++++++++++++++++++++++++
 3 files changed, 74 insertions(+), 3 deletions(-)

diffs (106 lines):

diff -r 51ffcbdea510 -r 1c910ef7f642 distrib/sets/lists/tests/mi
--- a/distrib/sets/lists/tests/mi       Thu Jun 25 15:21:56 2020 +0000
+++ b/distrib/sets/lists/tests/mi       Thu Jun 25 15:41:40 2020 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: mi,v 1.850 2020/06/25 15:01:35 jruoho Exp $
+# $NetBSD: mi,v 1.851 2020/06/25 15:41:40 jruoho Exp $
 #
 # Note: don't delete entries from here - mark them as "obsolete" instead.
 #
@@ -3995,6 +3995,7 @@
 ./usr/tests/sbin/ifconfig/Kyuafile             tests-sbin-tests        compattestfile,atf,kyua
 ./usr/tests/sbin/ifconfig/t_nonexistent                tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/ifconfig/t_repeated_scan      tests-sbin-tests        compattestfile,atf
+./usr/tests/sbin/ifconfig/t_repeated_updown    tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/ifconfig/t_tap                        tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/newfs                         tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/newfs/Atffile                 tests-sbin-tests        compattestfile,atf
diff -r 51ffcbdea510 -r 1c910ef7f642 tests/sbin/ifconfig/Makefile
--- a/tests/sbin/ifconfig/Makefile      Thu Jun 25 15:21:56 2020 +0000
+++ b/tests/sbin/ifconfig/Makefile      Thu Jun 25 15:41:40 2020 +0000
@@ -1,9 +1,9 @@
-# $NetBSD: Makefile,v 1.3 2020/06/25 14:24:46 jruoho Exp $
+# $NetBSD: Makefile,v 1.4 2020/06/25 15:41:40 jruoho Exp $
 
 .include <bsd.own.mk>
 
 TESTSDIR=      ${TESTSBASE}/sbin/ifconfig
 
-TESTS_SH=      t_nonexistent t_repeated_scan t_tap
+TESTS_SH=      t_nonexistent t_repeated_scan t_repeated_updown t_tap
 
 .include <bsd.test.mk>
diff -r 51ffcbdea510 -r 1c910ef7f642 tests/sbin/ifconfig/t_repeated_updown.sh
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/sbin/ifconfig/t_repeated_updown.sh  Thu Jun 25 15:41:40 2020 +0000
@@ -0,0 +1,70 @@
+# $NetBSD: t_repeated_updown.sh,v 1.1 2020/06/25 15:41:40 jruoho Exp $
+#
+# Copyright (c) 2020 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# This code is derived from software contributed to The NetBSD Foundation
+# by Jukka Ruohonen.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+atf_test_case repeated_updown
+repeated_updown_head() {
+       atf_set "require.user" "root"
+       atf_set "descr" "Test with ifconfig(8) that repeated " \
+               "up/down does not cause a panic (PR kern/52771)"
+}
+
+repeated_updown_body() {
+
+       # Try to avoid stalling any automated test runs.
+       #
+       n=35
+
+       for i in $(ifconfig -l); do
+
+               state="up"
+               ifconfig -s $i
+
+               if [ $? -eq 1 ]; then
+                       state="down"
+                       ifconfig $i up
+                       echo "Initialized $i up"
+               fi
+
+               while [ $n -gt 0 ]; do
+                       ifconfig $i down
+                       echo "Test $n: $i down"
+                       ifconfig $i up
+                       echo "Test $n: $i up"
+                       n=$(expr $n - 1)
+               done
+
+               ifconfig $i $state
+               echo "Restored state of $i to $state"
+               sleep 1
+       done
+}
+
+atf_init_test_cases() {
+       atf_add_test_case repeated_updown
+}



Home | Main Index | Thread Index | Old Index